

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author DDDEN!SSS
 */
public class Export { //конвертирование файла
    private static final String ns = "\r\n"; //новая строка
    private static final int scale = 150;
    private static final char open = "(".toCharArray()[0];
    private static final char close = ")".toCharArray()[0];
        
    private static final String vertex = "coords";
    private static final String color = "Colors";
    private static final String polygon = "Polygon";
    
    private static final String myVertex = "Vertex(";
    private static final String myColor = "Color(";
    private static final String myPolygon3V = "Polygon3V(";
    private static final String myPolygon4V = "Polygon4V(";
    
    public static byte[] export(byte[] bac) {
        String s = "";
        try {
            String bacStr = new String(bac);
            
            
            s = loadVertex(bacStr);
            s += ns;
            s += loadColor(bacStr);
            s += ns;
            s += loadPolygon(bacStr);
            
            
        } catch(Exception e) {System.err.println("ERROR Export "+e);}
        
        return s.getBytes();
    }
    
    
    
    
    
    private static String loadVertex(String bacStr) {
        String vertexes = myVertex;
        boolean ifOpen = false;
        int i = bacStr.indexOf(vertex);
        int ii = i;
        
        while(true) {
            if(bacStr.charAt(i) == open) {
                ifOpen = true;
                ii=i;
            }
            if(bacStr.charAt(i) == close) {
                if( !ifOpen ) {
                    break;
                }
                ifOpen = false;
                String v =  bacStr.substring(ii+6, i-1);
                vertexes += ver(v);
            }
            i++;
        }
        vertexes += ")";
        return vertexes;
    }
    private static String ver(String ver) { //конвертируем вершину в наш формат
        int i1 = ver.indexOf(" ");
        int i2 = ver.lastIndexOf(" ");
        
        String x = ver.substring(0, i1);
        String y = ver.substring(i1, i2);
        String z = ver.substring(i2, ver.length());
        
        int X = (int)(Float.parseFloat(x)*scale);
        int Y = (int)(Float.parseFloat(y)*scale);
        int Z = (int)(Float.parseFloat(z)*scale);
        
        return X+","+Y+","+Z+";";
    }
    
    
    
    
    
    
    
    
    private static String loadColor(String bacStr) {
        String colors = myColor;
        
        boolean ifOpen = false;
        int i = bacStr.indexOf(color);
        int ii = i;
        
        while(true) {
            if(bacStr.charAt(i) == open) {
                ifOpen = true;
                ii=i;
            }
            if(bacStr.charAt(i) == close) {
                if( !ifOpen ) {
                    break;
                }
                ifOpen = false;
                String c =  bacStr.substring(ii+2, i-1);
                colors += col(c);
            }
            i++;
        }
        colors += ")";
        return colors;
    }
    private static String col(String col) { //конвертируем цвет в наш формат
        int i1 = col.indexOf(" ", 3);
        int i2 = col.lastIndexOf(" ");
        
        String r = col.substring(3, i1);
        String g = col.substring(i1+1, i2);
        String b = col.substring(i2+1, col.length());
        
        int R = (int)(Float.parseFloat(r)*250);
        int G = (int)(Float.parseFloat(g)*250);
        int B = (int)(Float.parseFloat(b)*250);
        
        String rr = Integer.toHexString(R);
        if(rr.length()==1) {
            rr = "0"+rr;
        }
        String gg = Integer.toHexString(G);
        if(gg.length()==1) {
            gg = "0"+gg;
        }
        String bb = Integer.toHexString(B);
        if(bb.length()==1) {
            bb = "0"+bb;
        }
        
        return Integer.valueOf(rr+gg+bb, 16).toString()+";";
    }
    
    
    
    
    private static String loadPolygon(String bacStr) {
        String polygons3V = myPolygon3V;
        String polygons4V = myPolygon4V;
        
        int ifOpen = 0;
        
        int i = bacStr.indexOf(polygon);
        int ii = i; //номер открывающийся скобки "("
        
        while(true) {
            if(bacStr.charAt(i) == open) {
                if(ifOpen==0) {
                    ii=i;
                }
                ifOpen++;
            }
            if(bacStr.charAt(i) == close) {
                if(ifOpen<0) {
                    break;
                }
                ifOpen--;
                if(ifOpen==0) {
                    String p =  bacStr.substring(ii+7, i-1);
                    
                    if(-1 != p.indexOf("i3")) { //полигон из 3 вершин
                        polygons3V += pol(p);
                    } else { //полигон из 4 вершин
                        polygons4V += pol(p);
                    }
                }
            }
            i++;
        }
        
        polygons3V += ")";
        polygons4V += ")";
        
        return polygons3V+ns+polygons4V;
    }
    
    
    private static String pol(String pol) { //конвертируем полигон в наш формат
        int c = pol.indexOf(" ");
        String col = pol.substring(0, c); //номер цвет полигона
        
        int cl = pol.indexOf(")");
        pol = pol.substring(c+6, cl-1);
        
        int i1 = pol.indexOf(" ");
        int i2 = pol.indexOf(" ", i1+1);
        int i3 = pol.indexOf(" ", i2+1);
            
        String a1 = pol.substring(0, i1);
        String a2 = pol.substring(i1+1, i2);
        if(i3 != -1) {
            String a3 = pol.substring(i2+1, i3);
            String a4 = pol.substring(i3+1, pol.length());
            return a1+","+a2+","+a3+","+a4+","+col+";";
        } else {
            String a3 = pol.substring(i2+1, pol.length());
            return a1+","+a2+","+a3+","+col+";";
        }
    }
    
    
    
    
    
    
    
    
    
    
    
    
    
    
}
